## fluxus-0.16rc3.tar.gz

=== SConstruct ===
# -*- mode: python; -*-
################################################################################
# Top level SConscript for fluxus
#
# Checks all dependencies needed, builds the fluxus canvas
# application, then calls the sconscripts for libfluxus and
# the fluxus PLT modules

import os, sys

MajorVersion = "0"
MinorVersion = "16"
FluxusVersion = MajorVersion+MinorVersion
# remember to change fluxa too...
Target = "fluxus"

# changed prefix and pltprefix so they can be invoked at runtime
# like scons Prefix=/usr PLTPrefix=/usr instead of default /usr/local

DESTDIR = ARGUMENTS.get('DESTDIR', '')
# this makes DESTDIR relative to root of the source tree, no matter
# where we are
if len(DESTDIR)>0 and DESTDIR[0] != "/":
                DESTDIR = "#" + DESTDIR

if sys.platform == 'darwin':
	AddOption('--app', action='store_true', help='Build OSX application')
	file = os.popen('dirname "`which mzscheme`"')
	PLTBin = file.read()
	file.close()
	Prefix = ARGUMENTS.get('Prefix','/opt/local')
	PLTPrefix = ARGUMENTS.get('PLTPrefix', PLTBin[:-5])
	PLTInclude = ARGUMENTS.get('PLTInclude', PLTPrefix + "/include")
	PLTLib = ARGUMENTS.get('PLTLib', PLTPrefix + "/lib")
elif sys.platform == 'win32':
	Prefix = ARGUMENTS.get('Prefix','c:/Program Files/Fluxus')
	PLTPrefix = ARGUMENTS.get('PLTPrefix','c:/Program Files/PLT')
	PLTInclude = ARGUMENTS.get('PLTInclude', PLTPrefix + "/include")
	PLTLib = ARGUMENTS.get('PLTLib', PLTPrefix + "/lib")
else:
	Prefix = ARGUMENTS.get('Prefix','/usr/local')
	PLTPrefix = ARGUMENTS.get('PLTPrefix','/usr/local')
	PLTInclude = ARGUMENTS.get('PLTInclude', PLTPrefix + "/include/plt")
	PLTLib = ARGUMENTS.get('PLTLib', PLTPrefix + "/lib/plt")
BinInstall = DESTDIR + Prefix + "/bin"

DataLocation = Prefix + "/share/fluxus-"+FluxusVersion
DataInstall = DESTDIR + DataLocation
FluxusCollectsLocation = Prefix + "/lib"
CollectsInstall = DESTDIR + FluxusCollectsLocation + "/fluxus-" + FluxusVersion
DocsInstall = DESTDIR + Prefix + "/share/doc/fluxus-" + FluxusVersion

if sys.platform == 'darwin' or sys.platform == 'win32':
        PLTCollectsLocation = PLTPrefix + "/collects/"
else:
        PLTCollectsLocation = PLTLib + "/collects/"

if sys.platform == 'darwin' and GetOption('app'):
        PLTCollectsLocation = '/Applications/Fluxus.app/Contents/Resources/collects/'
        FluxusCollectsLocation = '/Applications/Fluxus.app/Contents/Resources/collects/'
        DataLocation = '/Applications/Fluxus.app/Contents/Resources'

LibPaths     = [
        PLTLib,
        PLTLib+"/..",
        "/usr/lib",
        "../../libfluxus"]

IncludePaths = [
        "/usr/local/include",
        "/usr/include",
        "/usr/local/include/freetype2",  # arg - freetype needs to be
        "/usr/include/freetype2",        # on the include path :(
        PLTInclude,
        "../../libfluxus/src"]

################################################################################
# Make the "one" environment for building and installing

env = Environment(CCFLAGS = '-ggdb -pipe -Wall -O3 -ffast-math -Wno-unused -fPIC',
                  VERSION_NUM = FluxusVersion)

if env['PLATFORM'] == 'win32':
	IncludePaths += [ "/MinGW/include/freetype2" ]
	LibPaths += [ "/MinGW/lib" ]

if env['PLATFORM'] == 'darwin':
	IncludePaths += ['/opt/local/include', '/opt/local/include/freetype2']
	LibPaths += ['/opt/local/lib']

env.Append(CPPPATH = IncludePaths)
env.Append(LIBPATH = LibPaths)
env.Append(CCFLAGS=' -DFLUXUS_MAJOR_VERSION='+MajorVersion)
env.Append(CCFLAGS=' -DFLUXUS_MINOR_VERSION='+MinorVersion)
env.Append(CCFLAGS=" -DPLT_COLLECTS_LOCATION="+"\"\\\""+PLTCollectsLocation+"\"\\\"")
env.Append(CCFLAGS=" -DFLUXUS_COLLECTS_LOCATION="+"\"\\\""+FluxusCollectsLocation+"\"\\\"")
env.Append(CCFLAGS=" -DDATA_LOCATION="+"\"\\\""+DataLocation+"\"\\\"")

if ARGUMENTS.get("GLSL","1")=="1":
        env.Append(CCFLAGS=' -DGLSL')

if ARGUMENTS.get("STEREODEFAULT","0")=="1":
        env.Append(CCFLAGS=' -DSTEREODEFAULT')

if ARGUMENTS.get("ACCUM_BUFFER","0")=="1":
        env.Append(CCFLAGS=' -DACCUM_BUFFER')

if ARGUMENTS.get("MULTITEXTURING","1")=="0":
        env.Append(CCFLAGS=' -DDISABLE_MULTITEXTURING')

if ARGUMENTS.get("RELATIVE_COLLECTS","0")=="1":
	env.Append(CCFLAGS=' -DRELATIVE_COLLECTS')

static_modules=0
if ARGUMENTS.get("STATIC_MODULES","0")=="1":
	static_modules=1
	env.Append(CCFLAGS=' -DSTATIC_LINK')

static_everything=0
if ARGUMENTS.get("STATIC_EVERYTHING","0")=="1":
	static_everything=1
	static_modules=1
	env.Append(CCFLAGS=' -DSTATIC_LINK')

# need to do this to get scons to link plt's mzdyn.o
env["STATIC_AND_SHARED_OBJECTS_ARE_THE_SAME"]=1
MZDYN = PLTLib + "/mzdyn.o"

if env['PLATFORM'] == 'win32':
	# need to do this to get scons to link plt's mzdyn.o
	MZDYN = PLTLib + "/gcc/mzdyn.o"

	if ARGUMENTS.get("3M","1")=="1":
		env.Append(CCFLAGS=' -DMZ_PRECISE_GC')
		MZDYN = PLTLib + "/gcc/mzdyn3m.o"
else:
	# need to do this to get scons to link plt's mzdyn.o
	MZDYN = PLTLib + "/mzdyn.o"
	
	if ARGUMENTS.get("3M","1")=="1":
		env.Append(CCFLAGS=' -DMZ_PRECISE_GC')
		MZDYN = PLTLib + "/mzdyn3m.o"

################################################################################
# Figure out which libraries we are going to need

# First member of each list is a library, second - a header or headers list
# to be passed to the CheckLibWithHeader(...) at configure time.
# We may add extra libraries later on per platform basis
LibList = [["m", "math.h"],
                ["pthread", "pthread.h"],
                ["dl", "stdio.h"],
                ["mzscheme3m", PLTInclude + "/scheme.h"],
                ["jpeg", ["stdio.h", "stdlib.h", "jpeglib.h"]],
                ["tiff", "tiff.h"],
                ["freetype", "ft2build.h"],
                ["z", "zlib.h"],
                ["png", "png.h"],
                ["ode", "ode/ode.h"],
                ["sndfile", "sndfile.h"],
                ["fftw3", "fftw3.h"],
                ["lo", "lo/lo.h"],
                ["GLEW", "GL/glew.h"]]

if env['PLATFORM'] == 'win32':
	LibList = [["m", "math.h"],
			["freetype", "ft2build.h"],
            ["glew32", "GL/glew.h"],
            ["glut32", "GL/glut.h"],
            ["glu32", "GL/glu.h"],
            ["opengl32", "GL/gl.h"],
			["libmzsch3m_6mqxfs", PLTInclude + "/scheme.h"]]

if env['PLATFORM'] == 'posix':
        env.Prepend(LINKFLAGS = ["-rdynamic"])
        LibList += [["X11", "X11/Xlib.h"],
                    ["GL", "GL/gl.h"],
                    ["GLU", "GL/glu.h"],
                    ["glut", "GL/glut.h"],
                    ["asound", "alsa/asoundlib.h"]]

        env.Append(LIBPATH = ["/usr/X11R6/lib"])

        # add the X11 libs on - needed if we are not building on xorg
        if ARGUMENTS.get("X11",0):
                LibList=[["Xi", "X11/Xlib.h"],
                                 ["Xmu", "X11/Xlib.h"],
                                 ["Xext", "X11/Xlib.h"],
                                 ["Xt", "X11/Xlib.h"],
                                 ["SM", "X11/Xlib.h"],
                                 ["ICE", "X11/Xlib.h"]] + LibList;
elif env['PLATFORM'] == 'darwin':
        # add jack as a library if not making an app
        if not GetOption('app'):
            LibList += [["jack", "jack/jack.h"]]

        env.Append(FRAMEWORKS = ['GLUT', 'OpenGL', 'CoreAudio' ,'PLT_MrEd'],
                FRAMEWORKPATH = [PLTLib])

################################################################################
# Make sure we have these libraries availible

if not GetOption('clean'):
        print '--------------------------------------------------------'
        print 'Fluxus: Configuring Build Environment'
        print '--------------------------------------------------------'
        conf = Configure(env)

        # FIXME: check mzscheme3m framework properly on osx
        if env['PLATFORM'] == 'darwin':
                if not conf.CheckHeader('scheme.h'):
                        print "ERROR: 'mzscheme3m' must be installed!"
                        Exit(1)
                LibList = filter(lambda x: x[0] != 'mzscheme3m', LibList)

        # all libraries are required, and some of them require each other,
        # hence the order is important, and autoadd=1
        for (lib,headers) in LibList:
                if not conf.CheckLibWithHeader(lib, headers, 'C', autoadd = 1):
                        print "ERROR: '%s' must be installed!" % (lib)
                        Exit(1)

        if not conf.CheckFunc("dInitODE2"):
            env.Append(CCFLAGS=' -DGOODE_OLDE_ODE')

        # the liblo version 0.25 does not include the declaration of lo_arg_size anymore
        # This will be re-included in future version
        if not conf.CheckFunc("lo_arg_size_check", "#include <lo/lo.h>\n#define lo_arg_size_check() lo_arg_size(LO_INT32, NULL)", "C++"):
            env.Append(CCFLAGS=' -DNO_LO_ARG_SIZE_DECL')

        env = conf.Finish()
        # ... but we shouldn't forget to add them to LIBS manually
        env.Replace(LIBS = [rec[0] for rec in LibList])

# replace libs with static libs if building an osx app
if env['PLATFORM'] == 'darwin' and GetOption('app'):
	for l in ['png', 'tiff', 'GLEW', 'z', 'sndfile', 'fftw3', 'freetype', 'ode', 'jpeg']:
		env['LIBS'].remove(l)
		env['LIBS'].append(File('/opt/local/lib/lib%s.a' % l))

################################################################################
# Build the fluxus application
Install = BinInstall

# need to build the bytecode for the base scheme library
# this is the wrong place to do this
if not GetOption('clean'):
	if static_modules:
		# in static mode, we want to embed all of plt we need
		os.system("mzc --c-mods src/base.c \
			++lib scheme/base  \
			++lib scheme/base/lang/reader  \
			++lib xml/xml \
			++lib compiler \
			++lib mzscheme \
			++lib mzlib/string \
			++lib setup   \
			++lib config  \
			++lib stxclass")
	else:
		os.system("mzc --c-mods src/base.c ++lib scheme/base")

Source = ["src/GLEditor.cpp",
                "src/GLFileDialog.cpp",
                "src/Interpreter.cpp",
                "src/Repl.cpp",
                "src/Recorder.cpp",
                "src/FluxusMain.cpp",
                "src/PolyGlyph.cpp",
                "src/main.cpp"]

app_env = env.Clone()

# statically link all the modules
if not GetOption('clean') and static_modules:
		
	# statically link in all the fluxus modules
	# these pick up the 'libfluxus-engine_ss.a' libs
	# rather than .so due to the 'lib' at the start
	app_env.Append(LIBPATH = ["modules/fluxus-engine/"])
	app_env.Append(LIBPATH = ["modules/fluxus-osc/"])
	app_env.Append(LIBPATH = ["modules/fluxus-audio/"])
	app_env.Append(LIBPATH = ["modules/fluxus-midi/"])
	app_env.Append(LIBPATH = ["libfluxus/"])
	app_env.Append(LIBS = ["fluxus-engine_ss"])
	app_env.Append(LIBS = ["fluxus-osc_ss"])
	app_env.Append(LIBS = ["fluxus-audio_ss"])
	app_env.Append(LIBS = ["fluxus-midi_ss"])
	
	if static_everything:
		# this is all a bit fragile, due to the need to put all the 
		# dependancies of the dynamic libraries here, in the right order
		
		# start off with the first options
		linkcom = " -static-libgcc -Wl,-Bstatic -lstdc++ -ljack -lrt -lasound \
			-lfluxus -lpthread_nonshared "
	
		app_env['LIBS'].remove("pthread")
		app_env['LIBS'].remove("dl")
	
		# now go through the rest of the libs, removing them from 
		# the environment at the same time
		for i in " X11 GLEW GLU glut asound m ode fftw3 mzscheme3m png tiff \
					jpeg freetype sndfile lo z ".split():
			app_env['LIBS'].remove(i)
			linkcom+="-l"+i+" "
	
		# add the remaining dependancies
		app_env.Append(LINKCOM = linkcom + ' -lFLAC -logg -Wl,-Bdynamic')
	else:
		# statically link in mzscheme only
		app_env['LIBS'].remove('mzscheme3m')
		app_env.Append(LINKCOM = ' -Wl,-Bstatic -lmzscheme3m -Wl,-Bdynamic')
		
		# have to add the libs needed by the fluxus modules here
		app_env.Append(LIBS = ["fluxus"])
		app_env.Append(LIBS = ["jack"])
		app_env.Append(LIBS = ["asound"])

app_env.Program(source = Source, target = Target)

=== debian/changelog ===
fluxus (0.16rc3-1) gutsy; urgency=low

  * new release

 -- Dave Griffiths <dave@pawfal.org>  Sat, 2 May 2009 12:43:11 +0100

fluxus (0.14b1-2) gutsy; urgency=low

  * Refreshed quilt'ed patches

 -- Artem Baguinski <artm@v2.nl>  Thu, 10 Jan 2008 12:43:11 +0100

fluxus (0.14b1-1) gutsy; urgency=low

  * New upsream release
  * Fixed search paths for resources

 -- Artem Baguinski <artm@v2.nl>  Thu, 10 Jan 2008 10:25:16 +0100

fluxus (0.13rc2-1ubuntu1) UNRELEASED; urgency=low

  * New upstream release (fluxus-0.13rc2)
    - switched from guile to mzscheme
  * Using quilt to maintain local patches

 -- Artem Baguinski <artm@v2.nl>  Thu, 22 Nov 2007 15:46:05 +0000

fluxus (0.9-1) unstable; urgency=low

  * New upstream release (fluxus-0.9rc1)

 -- Javier Candeira <javier@candeira.com>  Fri, 10 Mar 2006 13:19:39 +0100

fluxus (0.8-1) unstable; urgency=low

  * New upstream release
  * Updated build-dependencies to include libjack0.80.0-dev

 -- Javier Candeira <javier@candeira.com>  Wed,  8 Mar 2006 21:10:27 +0100

fluxus (0.7rc1-2) unstable; urgency=low

  * Updated dependencies. As libportaudio-dev is now on Debian, we don't
    need to package it ourselves. We make it depend on the Debian lib.
  * Package passes from Miriam Ruiz to Javier Candeira.

 -- Javier Candeira <javier@candeira.com>  Wed,  2 Nov 2005 19:21:32 +0100

fluxus (0.7rc1-1) unstable; urgency=low

  * Initial Release.

 -- Miriam Ruiz <little_miry@yahoo.es>  Fri,  1 Jul 2005 23:51:13 +0000

=== debian/control ===
Source: fluxus
Section: graphics
Priority: optional
Maintainer: Dave Griffiths <dave@pawfal.org>
Uploaders: Artem Baguinski <artm@v2.nl>, Javier Candeira <javier@candeira.com>, Miriam Ruiz <little_miry@yahoo.es>
Build-Depends: debhelper (>= 4.0.0), quilt, patchutils, scons, libode-dev, fftw3-dev, libsndfile1-dev, liblo0-dev, libtiff-dev, libpng-dev, libglew-dev, xlibmesa-gl-dev | x11proto-gl-dev, libglu1-xorg-dev | libglu1-mesa-dev, freeglut3-dev, libjack-dev, libfreetype6-dev
Standards-Version: 3.7.3
XS-Vcs-Bzr: http://bazaar.launchpad.net/~fluxus-maintainers/fluxus/dev

Package: fluxus
Architecture: any
Depends: ${shlibs:Depends}
Description: create graphics live, interpreting audio and OSC input
 Fluxus allows you to write Scheme scripts that create graphics live,
 interpreting audio and OSC input as a source of animation data. Fluxus also
 uses a fully featured physics library, which means you can script physical
 properties into objects and simulate them in realtime.
 .
 The built in scheme code editor runs on top of the renderer, which means you
 can edit the scripts while they are running. This allows Fluxus to be used
 for livecoding performances, or simply as a fast feedback way of
 experimenting or learning about graphics and animation.
 .
 Fluxus lends itself to procedural modelling and animation, there is no model
 import functionality, only simple primitives. There is an expermental
 procedural modelling tool however, and full support for texturing and basic
 material properties.
 .
 Web Page: http://www.pawfal.org/fluxus/

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

CFLAGS = -Wall -g

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
endif

configure: configure-stamp
configure-stamp:
	dh_testdir
	# Add here commands to configure the package.
	touch configure-stamp

build: build-stamp

build-stamp: configure-stamp 
	dh_testdir
	export PATH=$(PATH):/usr/local/bin
	echo $(PATH)
	scons Prefix=/usr PLTPrefix=/usr STATIC_MODULES=1
	touch build-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f config.log
	rm -f build-stamp configure-stamp
	# Add here commands to clean up after the build process.
	scons -c Prefix=/usr PLTPrefix=/usr STATIC_MODULES=1
	rm -rf .sconf_temp/
	rm -f .sconsign src/.sconsign libfluxus/src/.sconsign libfluxphysics/src/.sconsign
	rm -f .sconsign.dblite
	if test -d patches && quilt applied ; then quilt pop -a ; rm -rf .pc ; fi
	rm -f patches patch-stamp
	dh_clean 

install: build
	dh_testdir
	dh_testroot
	dh_clean -k 
	dh_installdirs

	# Add here commands to install the package into debian/fluxus.
	scons Prefix=/usr PLTPrefix=/usr DESTDIR=debian/fluxus STATIC_MODULES=1 install

# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs CHANGES
	dh_installdocs
	dh_installexamples
	dh_installmenu
	dh_installman
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure
